#ifndef _JTYPE_H_
#define _JTYPE_H_



#include <sys/types.h>


//#ifndef _JAVASOFT_JNI_H_
	#ifdef __WIN32__
	typedef __int8  		 j_byte;
	typedef unsigned __int8  j_boolean;
	typedef __int16          j_short;
	typedef unsigned __int16 j_char;
	typedef __int32          j_int;
	typedef __int64          j_long;
	#else
	typedef int8_t         	 j_byte;
	typedef u_int8_t         j_boolean;
	typedef int16_t          j_short;
	typedef u_int16_t        j_char;
	typedef int32_t          j_int;
	typedef int64_t          j_long;
	#endif
	typedef float            j_float;
	typedef double           j_double;
//#endif // _JAVASOFT_JNI_H_






#ifdef __WIN32__
typedef __int8           int8;
typedef __int16          int16;
typedef __int32          int32;
typedef __int64          int64;
#else
typedef int8_t           int8;
typedef int16_t          int16;
typedef int32_t          int32;
typedef int64_t          int64;
#endif

#ifdef __WIN32__
typedef unsigned __int8  uint8;
typedef unsigned __int16 uint16;
typedef unsigned __int32 uint32;
typedef unsigned __int64 uint64;
#else
typedef u_int8_t         uint8;
typedef u_int16_t        uint16;
typedef u_int32_t        uint32;
typedef u_int64_t        uint64;
#endif

#define true			(j_boolean)1
#define false			(j_boolean)0

struct Utf8 {
	j_short 		size;
	uint8*		utf8;
};

typedef struct Utf8 UTF8;
typedef UTF8 *UTF8_PTR;

#define CONST_INT_64(x) x##LL
#endif //_JTYPE_H_
