#include "unit/unit.h"
#include <stdio.h>

#include "socket/socket.h"
#include "event/eventqueue_table.h"
#include "event/event.h"
#include "parser/parser.h"






void rmiunit_event_received(EVENT_PTR evt, LISTENER_PTR node)
{
	fprintf(stdout, "rmi");
	unit_event_received(evt, node);
}


UNIT_PTR rmiunit_create(char* sm_filename)
{
	
	UNIT_PTR u = unit_create(sm_filename, NULL);
	fprintf(stdout, "Creating rmi unit %p\n", u);
	/*		
	PARSER_PTR p = rmi_parser_create(u);
	char key[255];
	strcpy(key, "rmi");
	unit_addparser(u, key, p);	
	unit_add_msglistener_parser(u, p);
 	u->current_parser = p;
	parser_add_evtlistener_unit(p, u);

	COMPOSER_PTR c = rmicomposer_create(u);
	char key1[255];
	strcpy(key1, "rmi");
	unit_addcomposer(u, key1, c);
*/
	
	COMPOSER_PTR c2 = jrmp_composer_create(u);
	char key4[255];
	strcpy(key4, "JRMP");
	unit_addcomposer(u, key4, c2);
	
	/*
	SOCKET_PTR s2 = http_socket_create(u);
	char key3[255];
	strcpy(key3, "HTTP");
	unit_addsocket(u, key3, s2);	
	*/

	
	/*
	 *	to be moved in monitor and find a generic solution
	 *	for unit creation with factory and set as listeners
	 *	on unit of the other and the other way round 
	 */

	 UNIT_PTR soap_unit = soapunit_create2("soapunit.sm");
	 unit_add_evtlistener_unit(u, soap_unit);
	 unit_add_evtlistener_unit(soap_unit, u);
	 

	 
	 u->func_event_received = rmiunit_event_received; 
	 
	return u;	
}


UNIT_PTR rmiunit_create2(char* sm_filename)
{
	UNIT_PTR u = unit_create(sm_filename, NULL);
	fprintf(stdout, "Creating rmi unit %p\n", u);
	/*		
	PARSER_PTR p = rmi_parser_create(u);
	char key[255];
	strcpy(key, "rmi");
	unit_addparser(u, key, p);	


	COMPOSER_PTR c = rmicomposer_create(u);
	char key1[255];
	strcpy(key1, "rmi");
	unit_addcomposer(u, key1, c);
*/
	COMPOSER_PTR c2 = jrmp_composer_create(u);
	char key4[255];
	strcpy(key4, "JRMP");
	unit_addcomposer(u, key4, c2);

	/*
	SOCKET_PTR s2 = http_socket_create(u);
	char key3[255];
	strcpy(key3, "HTTP");
	unit_addsocket(u, key3, s2);	
*/
	 
	 u->func_event_received = rmiunit_event_received; 
	 
	return u;	
}

