#include "unit/unit.h"
#include <stdio.h>

#include "socket/socket.h"
#include "event/eventqueue_table.h"
#include "event/event.h"
#include "parser/parser.h"





void wsdproxy_unit_event_received(EVENT_PTR evt, LISTENER_PTR node)
{
	fprintf(stdout, "WSDPROXY");
	unit_event_received(evt, node);
}


UNIT_PTR wsdproxy_unit_create2(char* sm_filename)
{
	fprintf(stdout, "Creating WSDPROXY unit\n");
	
	UNIT_PTR u = unit_create(sm_filename, NULL);
	
	COMPOSER_PTR c = wsdproxy_composer_create(u);
	char key1[255];
	strcpy(key1, "WSDPROXY");
	unit_addcomposer(u, key1, c);
	
 	

	 
	 u->func_event_received = wsdproxy_unit_event_received; 
	 
	return u;	
}



