#ifndef _MSG_H_

#define _MSG_H_


typedef struct msg {
	int length;
	char* data;
	char* src_address;
	int src_port;
	char* dest_address;
	int dest_port;
	
	void* src;
	
	int src_socket_id;
} MSG;
typedef MSG* MSG_PTR;

MSG_PTR msg_create(char* data, int length, char* src_addr, int src_port, char* dest_addr, int dest_port, void* src);
MSG_PTR msg_create_sock_id(char* data, int length, char* src_addr, int src_port, char* dest_addr, int dest_port, int src_socket_id, void* src);
void msg_free(MSG_PTR msg);

#endif //_MSG_H_
