#ifndef _SOAPPARSER_H_
#define _SOAPPARSER_H_

#include "stdio.h"
#include "stdlib.h"
#include "malloc.h"

#define TAG_START '<'
#define TAG_END '>'
#define SPACE ' '
#define QUESTIONMARK '?'
#define MARKUP_END_TAG "</"
#define MARKUP_END_TAG_OTHER "/>"

//#define FILE_PATH "soapres.xml"

#define STR_HEADER "Header"
#define STR_BODY "Body"
#define STR_RESPONSE "Response"
#define STR_RESULT "rpc:result"
#define STR_TYPE "type"

//#define TRUE 1
//#define FALSE 0


typedef struct
{
	int iStart;
	int iEnd;
	char *tagStr;
	char *name;
	char *value;
	char* datatype;	
	struct TAG_DETAILS* next;
}TAG_DETAILS;

/*
typedef struct Argument 
{
	char* name;
	int dir;
	char* datatype;
	char* value;
	struct Argument* next;
} ARGUMENTDEF, *ARGUMENTDEFPTR;

*/

#endif //_SOAPPARSER_H_
