#ifndef  _CLASSDESCRIPION_H_
#define _CLASSDESCRIPION_H_

#ifndef _JCONST_H_
#include <io/jconst.h>
#endif //_JCONST_H_
#ifndef _FIELD_H_
#include <ser/field.h>
#endif //_FIELD_H_

struct ClassDescription {
    j_int  		id;
    j_int  		type;
    char*		name;
    SER_FIELDPTR	field;
    j_short   	sizeField;
    struct 		ClassDescription *superClass;
    j_byte*  	data;
    j_long       serial;
    j_byte       flag;
    char* annotation;
};

typedef struct ClassDescription CLASSDESC;
typedef CLASSDESC *CLASSDESCPTR;


struct ObjectDescription {
    CLASSDESCPTR  classDescr;
    char*         name;
    char* 	  ip;
    j_int	  port;
    j_long	  objNum;
    j_int	  unique;
    j_long	  time;         
    j_short	  count;
    j_byte	  bool;
};

typedef struct ObjectDescription OBJECTDESC;
typedef OBJECTDESC *OBJECTDESCPTR;
#endif
